#define HASHSIZE 20
#define PEERIDLEN 20

enum {		
	BThas = (1<<0),		/* least sig bit: "has that piece" */
	BTshar = (1<<1),	/* 2nd least sig bit: "piece is shared" */
	BThashar = BThas|BTshar,
	BTnone = 0,
};

typedef struct Piece Piece;
struct Piece{
	int index;
	char status;
	Piece *next;
};

typedef struct Peer Peer;
struct Peer {
	char *address;
	char *id;
	int port;
	char seeder;
	char busy;
	char *bitfield;
	Piece *pieceslist;
	int piecesnb;
};

typedef struct Torrent Torrent;
struct Torrent {
	char *announce;
	Rune **announcelist;
	int annlistsize;
	Rune *comment;
	Rune *createdby;
	uvlong creationdate; 
	Rune *encoding;
	int multifile;
	uint piecelength;
	Rune *name;
	int piecesnb;
	uchar **sha1list;
	uint private;
	uvlong *filelength;
	Rune **filepath;
	Rune **filemd5sum;
	int filesnb;
	uchar *infohash;
	int infosize;	
	Piece *pieceslist;	 
	char **datafiles;
	int *fileborder;
	int *firstoffset;
	int lastpiece;
	Peer **peers;
	char peersnb;
};

char *forgerequest(Torrent *tor, char *req);
int checkpiece(char *data, Torrent *tor, int index);
void preppieceslist(Torrent *tor);
void writedata(ulong index, char *data, Torrent *tor, Peer *peer);
void preppeerspieces(Torrent *tor, Peer *peer);
